%
% rel = encrelrot(model, faces, template, neigh)
%
function rel = encrelrot(model, faces, template, neigh)

m = model;

step = 15;
rel = zeros(1, size(faces,1) * step);

N = zeros(3, 1);
tn = zeros(3, 1);

Rs = cell(size(faces,1),1);

at = 1;
for i = 1:size(faces,1)
    v = faces(i,:);
    origin = template(v(1),:)';
    e1 = template(v(2),:)' - origin;
    e2 = template(v(3),:)' - origin;
%        N = cross(e1, e2);
    N(1) = e1(2)*e2(3) - e1(3)*e2(2);
    N(2) = e1(3)*e2(1) - e1(1)*e2(3);
    N(3) = e1(1)*e2(2) - e1(2)*e2(1);
    N = N / norm(N);
    src = [e1, e2, N];

    to = m(v(1),:)';
    t1 = m(v(2),:)' - to;
    t2 = m(v(3),:)' - to;
%        tn = cross(t1, t2);
    tn(1) = t1(2)*t2(3) - t1(3)*t2(2);
    tn(2) = t1(3)*t2(1) - t1(1)*t2(3);
    tn(3) = t1(1)*t2(2) - t1(2)*t2(1);
    tn = tn / norm(tn);
    tgt = [t1, t2, tn];
    T = tgt / src;

    R = T;
    [U, S, V] = svd(R);
    R = U * V';
    if det(R) < 0
        R = R * -1;
        disp('flipping');
    end
    Rs{i} = R;

    S = R \ T;

    at = at + 9;

    rel(at:at+5) = [S(1,:), S(2,2:3), S(3,3)];
    at = at + 6;
end
for i = 1:size(faces,1)
        delta = Rs{i} \ Rs{neigh(i, 1)};
        rel((i-1)*step+1:(i-1)*step+3) = torotvec(delta);
        delta = Rs{i} \ Rs{neigh(i, 2)};
        rel((i-1)*step+4:(i-1)*step+6) = torotvec(delta);
        delta = Rs{i} \ Rs{neigh(i, 3)};
        rel((i-1)*step+7:(i-1)*step+9) = torotvec(delta);
end
