%
% R = fromrotvec(r)
%
% convert rotation vector into rotation matrix
%
function R = fromrotvec(r)

if r == zeros(3,1)
    R = eye(3);
else
    theta = norm(r);
    r = -r / theta;

    R = [ 0    -r(3)  r(2); ...
          r(3)  0    -r(1); ...
         -r(2)  r(1)  0  ];
    R = R * sin(theta) + (R * R) * (1 - cos(theta)) + eye(3);
end
