%
% r = torotvec(R)
%
% convert rotation matrix into rotation vector representation
%
% thanks for this much more stable version to
% http://rip94550.wordpress.com/2008/09/28/angle-and-axis-of-rotation-2-the-two-correct-answers/
%
function r = torotvec(R)

RRt = R - R';
r = [RRt(2,3);RRt(3,1);RRt(1,2)];
len = norm(r);
if len == 0
    return
end
r = r * (atan2(len, R(1,1)+R(2,2)+R(3,3)-1) / len);
