%
% writeobj(name, vertices, faces, normals)
%
function writeobj(name, vertices, faces, normals, uvcoords)

if ~exist('vertices','var') || isempty(vertices)
    disp('error: need vertices to save obj');
    return
end

if exist('normals','var') && ~isempty(normals) && size(normals,1) ~= size(vertices,1)
    disp('error: normals must have the same number of rows as vertices');
    return
end

if size(vertices,2) ~= 3
    disp('error: vertices must be three-dimensional');
    return
end

if exist('normals','var') && ~isempty(normals) && size(normals,2) ~= 3
    disp('error: normals must be three-dimensional');
    return
end

disp('matlab writeobj');

fid = fopen(name, 'w');
if fid < 0
    disp('error: file could not be opened');
end

for i = 1:size(vertices,1)
    fprintf(fid, 'v %f %f %f\n', vertices(i,1), vertices(i,2), vertices(i,3));
end

if exist('uvcoords','var') && ~isempty(uvcoords)
    for i = 1:size(uvcoords,1)
        fprintf(fid, 'vt %f %f\n', uvcoords(i,1), uvcoords(i,2));
    end
end

if exist('normals','var') && ~isempty(normals)
    for i = 1:size(normals,1)
        fprintf(fid, 'vn %f %f %f\n', normals(i,1), normals(i,2), normals(i,3));
    end
end

if exist('faces','var')
    for i = 1:size(faces,1)
        fprintf(fid, 'f %d %d %d\n', faces(i,1), faces(i,2), faces(i,3));
    end
end

fclose(fid);
